#### Linux From Scratch - Version 7.9

### Chapter 5. Constructing a Temporary System

- Prev

  Linux-4.4.2 API Headers

- Next

  Libstdc++-5.3.0

- Up
- Home

# 5.7. Glibc-2.23

The Glibc package contains the main C library. This library provides the basic routines for allocating memory, searching directories, opening and closing files, reading and writing files, string handling, pattern matching, arithmetic, and so on.

Approximate build time: 4.0 SBU
Required disk space: 650 MB

## 5.7.1. Installation of Glibc

The Glibc documentation recommends building Glibc in a dedicated build directory:

    mkdir -v build
    cd       build

Next, prepare Glibc for compilation:

    ../configure                             \
          --prefix=/tools                    \
          --host=$LFS_TGT                    \
          --build=$(../scripts/config.guess) \
          --disable-profile                  \
          --enable-kernel=2.6.32             \
          --enable-obsolete-rpc              \
          --with-headers=/tools/include      \
          libc_cv_forced_unwind=yes          \
          libc_cv_ctors_header=yes           \
          libc_cv_c_cleanup=yes

The meaning of the configure options:

`--host=$LFS_TGT, --build=$(../scripts/config.guess)`

  The combined effect of these switches is that Glibc's build system configures itself to cross-compile, using the cross-linker and cross-compiler in `/tools`.

`--disable-profile`

  This builds the libraries without profiling information. Omit this option if profiling on the temporary tools is necessary.

`--enable-kernel=2.6.32`

  This tells Glibc to compile the library with support for 2.6.32 and later Linux kernels. Workarounds for older kernels are not enabled.

`--enable-obsolete-rpc`

  This installs NIS and RPC related headers that are not installed by default. They are required to build GCC and by several BLFS packages.

`--with-headers=/tools/include`

  This tells Glibc to compile itself against the headers recently installed to the tools directory, so that it knows exactly what features the kernel has and can optimize itself accordingly.

`libc_cv_forced_unwind=yes`

  The linker installed during Section 5.4, “Binutils-2.26 - Pass 1” was cross-compiled and as such cannot be used until Glibc has been installed. This means that the configure test for force-unwind support will fail, as it relies on a working linker. The libc_cv_forced_unwind=yes variable is passed in order to inform configure that force-unwind support is available without it having to run the test.

`libc_cv_c_cleanup=yes`

  Similarly, we pass libc_cv_c_cleanup=yes through to the configure script so that the test is skipped and C cleanup handling support is configured.

`libc_cv_ctors_header=yes`

  Similarly, we pass libc_cv_ctors_header=yes through to the configure script so that the test is skipped and gcc constructor support is configured.

During this stage the following warning might appear:

>     configure: WARNING:
>     *** These auxiliary programs are missing or
>     *** incompatible versions: msgfmt
>     *** some features will be disabled.
>     *** Check the INSTALL file for required versions.

The missing or incompatible msgfmt program is generally harmless. This msgfmt program is part of the Gettext package which the host distribution should provide.

### Note

There have been reports that this package may fail when building as a "parallel make". If this occurs, rerun the make command with a "-j1" option.

Compile the package:

    make

Install the package:

    make install

### Caution

At this point, it is imperative to stop and ensure that the basic functions (compiling and linking) of the new toolchain are working as expected. To perform a sanity check, run the following commands:

    echo 'int main(){}' > dummy.c
    $LFS_TGT-gcc dummy.c
    readelf -l a.out | grep ': /tools'

If everything is working correctly, there should be no errors, and the output of the last command will be of the form:

    [Requesting program interpreter: /tools/lib/ld-linux.so.2]

Note that for 64-bit machines, the interpreter name will be `/tools/lib64/ld-linux-x86-64.so.2`.

If the output is not shown as above or there was no output at all, then something is wrong. Investigate and retrace the steps to find out where the problem is and correct it. This issue must be resolved before continuing on.

Once all is well, clean up the test files:

    rm -v dummy.c a.out

### Note

Building Binutils in the section after next will serve as an additional check that the toolchain has been built properly. If Binutils fails to build, it is an indication that something has gone wrong with the previous Binutils, GCC, or Glibc installations.

Details on this package are located in Section 6.9.3, “Contents of Glibc.”

- Prev

  Linux-4.4.2 API Headers

- Next

  Libstdc++-5.3.0

- Up
- Home